/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: CompileRulePackageCommand.as 9121 2011-10-10 12:38:53Z durieuxp $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notificationeditor.command {
import com.adobe.cairngorm.control.CairngormEvent;

import mx.collections.ArrayCollection;
import mx.rpc.events.ResultEvent;

import org.ow2.jasmine.monitoring.eos.notificationeditor.event.SynchronizedRulePackageEvent;

import org.ow2.jasmine.monitoring.eos.notificationeditor.model.domain.SynchronizedRulePackage;

/**
 * Compile the rule package
 */
public class CompileRulePackageCommand extends AbstractCommand {

    private var synchronizedRulePackage:SynchronizedRulePackage = null;

    public function CompileRulePackageCommand() {
    }

    /**
     * Send the event to the java side, using the business layer of the pattern
     */
    override public function execute(event:CairngormEvent):void {
        synchronizedRulePackage = (event as SynchronizedRulePackageEvent).rulePackage;

        // Dispatch a notification to Kerneos
        debug("Compiling \"" + synchronizedRulePackage.rulePackage.displayName + "\".");

        delegate.responder = this;
        delegate.compileRulePackage(synchronizedRulePackage.rulePackage, model.ruleEngineName);
    }

    /**
     * Get the result of the java side. this method is called on each event
     * returned from the Java side.
     */
    override public function result(event:Object):void {
        // Retrieve the errors collection
        var errors:ArrayCollection = (event as ResultEvent).result as ArrayCollection;

        // Update the rule package errors collection
        synchronizedRulePackage.rulePackage.compilationErrors = errors;

        // Mark the compilation as checked
        synchronizedRulePackage.rulePackage.compilationChecked = true;
    }

}
}
