/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: SynchronizedRulePackageEvent.as 4798 2009-08-07 12:30:47Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notificationeditor.event {
import com.adobe.cairngorm.control.CairngormEvent;

import flash.events.Event;

import org.ow2.jasmine.monitoring.eos.notificationeditor.model.domain.SynchronizedRulePackage;

/**
 * An event type to carry rule packages
 *
 * @author Julien Nicoulaud
 */
public class SynchronizedRulePackageEvent extends CairngormEvent {

    // =====================================================================
    // Variables
    // =====================================================================

    // Event types

    public static var SAVE_SYNCHRONIZED_RULE_PACKAGE:String = "saveSynchronizedRulePackage";
    public static var SAVE_AND_CLOSE_SYNCHRONIZED_RULE_PACKAGE:String = "saveAndCloseSynchronizedRulePackage";
    public static var UPDATE_RULE_PACKAGE_METADATA:String = "updateRulePackageMetadata";
    public static var CONVERT_TO_TEXTUAL_PACKAGE:String = "convertToTextualPackage";
    public static var CREATE_TEXTUAL_VERSION:String = "createTextualVersion";
    public static var DELETE_RULE_PACKAGE:String = "deleteRulePackage";
    public static var COMPILE_RULE_PACKAGE:String = "compileRulePackage";
    public static var CHECK_NAME_AVAILABILITY:String = "checkNameAvailability";


    // Event variables

    public var rulePackage:SynchronizedRulePackage;


    // =====================================================================
    // Initialization
    // =====================================================================

    /**
     * Creates a new SynchronizedRulePackageEvent
     */
    public function SynchronizedRulePackageEvent(type:String, rulePackage:SynchronizedRulePackage) {
        super(type);
        this.rulePackage = rulePackage;
    }


    // =====================================================================
    // Utils
    // =====================================================================

    /**
     * Clone a SynchronizedRulePackageEvent
     */
    override public function clone():Event {
        return new SynchronizedRulePackageEvent(this.type, this.rulePackage);
    }

}
}
