/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notificationeditor.model {
import com.adobe.cairngorm.model.ModelLocator;

import org.ow2.jasmine.monitoring.eos.notificationeditor.business.NotificationEditorDelegate;
import org.ow2.jasmine.monitoring.eos.notificationeditor.model.domain.EngineDashboardModel;
import org.ow2.jasmine.monitoring.eos.notificationeditor.model.domain.RuleEditorModel;
import org.ow2.jasmine.monitoring.eos.notificationeditor.model.domain.RuleManagerModel;
import org.ow2.jasmine.monitoring.eos.notificationeditor.model.presentation.EngineDashboardPM;
import org.ow2.jasmine.monitoring.eos.notificationeditor.model.presentation.RuleEditorMainViewPM;
import org.ow2.jasmine.monitoring.eos.notificationeditor.model.presentation.RuleManagerPM;

/**
 * Cairngorm Model Locator for the rule editor
 *
 * @author Julien Nicoulaud
 */
[Bindable]
public class NotificationEditorModelLocator implements ModelLocator {

    public const ruleEngineName:String = "notification";

    /**
     * Rule engine dashboard domain model
     */
    public var ruleEditorModel:RuleEditorModel;

    /**
     * Rule manager domain model
     */
    public var ruleManagerModel:RuleManagerModel;

    /**
     * Rule engine dashboard presentation model
     */
    public var ruleEditorPresentationModel:RuleEditorMainViewPM;

    /**
     * Rule manager presentation model
     */
    public var ruleManagerPresentationModel:RuleManagerPM;

    /**
     * Rule engine dashboard domain model
     */
    public var engineDashboardModel:EngineDashboardModel;

    /**
     * Rule engine dashboard presentation model
     */
    public var engineDashboardPresentationModel:EngineDashboardPM;

    /**
     * Constructor
     */
    public function NotificationEditorModelLocator() {
        super();
        ruleEditorModel = new RuleEditorModel();
        ruleManagerModel = new RuleManagerModel();
        ruleEditorPresentationModel = new RuleEditorMainViewPM(ruleEditorModel);
        ruleManagerPresentationModel = new RuleManagerPM(ruleManagerModel);
        engineDashboardModel = new EngineDashboardModel();
        engineDashboardPresentationModel = new EngineDashboardPM(engineDashboardModel);

    }

    /**
     * Use only one delegate.
     */
    public var delegate:NotificationEditorDelegate = null;

    public function getDelegate():NotificationEditorDelegate {
        if (delegate == null) {
            delegate = new NotificationEditorDelegate();
        }
        return delegate;
    }

}
}
