/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: RulePackageSaveReportVO.as 9121 2011-10-10 12:38:53Z durieuxp $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notificationeditor.vo
{
import com.adobe.cairngorm.vo.IValueObject;

import mx.collections.ArrayCollection;


/**
* A data object reporting the server-side operations successes and failures when
* saving a rule package
*
* @author Julien Nicoulaud
*/
[Bindable]
public class RulePackageSaveReportVO implements IValueObject
{
    // =========================================================================
    // Constants
    // =========================================================================
    		
	/**
    * The potential operations
    */
    public static var OPERATION_ACTIVATE : String = "OPERATION_ACTIVATE";
    public static var OPERATION_DEACTIVATE : String = "OPERATION_DEACTIVATE";
    public static var OPERATION_UPDATE : String = "OPERATION_UPDATE";
    public static var OPERATION_SAVE : String = "OPERATION_SAVE";
    
    
    // =========================================================================
    // Variables
    // =========================================================================
    
    /**
    * A list of the operations completed successfully
    * Use the potential operations constants to feed this list.
    */
    public var successes : ArrayCollection;

    /**
     * A list of the failures
     * Each failure is a list of Strings following this structure by convention:
     *  - Operation name/title
     *  - Short statement describing the failure
     *  - (Optional) A stack trace
     */
    public var failures : ArrayCollection;

    public function RulePackageSaveReportVO() {
    }
}
}
